;==============================================================================
; ˿ڶ壨ַ
port8255A   equ 210h
port8255B   equ 211h
port8255C   equ 212h
port8255Cmd equ 213h

port8253_0  equ 220h
port8253_1  equ 221h
port8253Cmd equ 223h

io8259_0    equ 200h
io8259_1    equ 201h

ADC_S       equ 230h
ADC_O       equ 231h
ADC_E       equ 232h

;==============================================================================
; ݶζ
data        segment
    tcount  dw  0           ; жϼ0~1800 ں
    lampC   db  0ch,14h,21h,22h,0ffh
    potVal  db  ?
    stepBuf db  0
data        ends

;==============================================================================
; ջ
StackSeg  segment stack
    db  256 dup(?)
StackSeg  ends

;==============================================================================
; ζ
code    segment
    assume  cs:code, ds:data, ss:StackSeg

start:
    cli
    mov ax, data
    mov ds, ax

    ;--------------------- ʼ8259 ---------------------
    mov dx, io8259_0
    mov al, 00010011b
    out dx, al
    mov dx, io8259_1
    mov al, 00001000b
    out dx, al
    mov al, 00000001b
    out dx, al

    ; ж
    push ds
    mov ax, 0
    mov ds, ax
    lea ax, cs:int_proc
    mov si, 08h
    add si, si
    add si, si
    mov ds:[si], ax
    push cs
    pop ax
    mov ds:[si+2], ax
    pop ds
    in  al, dx
    and al, 11111110b
    out dx, al

    ;--------------------- ʼ8253 ---------------------
    mov ax, 0
    mov al, 00110110b
    mov dx, port8253Cmd
    out dx, al
    mov ax, 10000
    mov dx, port8253_0
    out dx, al
    mov al, ah
    out dx, al

    ;--------------------- ʼ8255 ---------------------
    mov dx, port8255Cmd
    mov al, 10001000b
    out dx, al

    mov stepBuf, 33h
    sti

;==============================================================================
; A/Dת
MainLoop:   
    mov dx, ADC_S
    out dx, al

CheckAD:
    mov dx, ADC_E
    in  al, dx
    test al, 01h
    jz   CheckAD
    mov dx, ADC_O
    in  al, dx
    mov potVal, al

;==============================================================================
; 
MotorDriverInit:   
    mov al, stepBuf
    mov dx, port8255C
    out dx, al

MotorDriverLoop:
    call    delay
    mov dx, port8255C
    in  al, dx

MotorCheckDir:
    mov ax, tcount
    cmp ax, 900
    jae DirIsReverse
    mov al, stepBuf
    ror al, 1         ; ת
    jmp DirUpdate

DirIsReverse:
    mov al, stepBuf
    rol al, 1         ; ת

DirUpdate:
    mov dx, port8255C
    out dx, al
    mov stepBuf, al

;==============================================================================
; ͨƣʱ 1800 (6s,3s,6s,3s)
; ·: 0~599
; ·: 600~899
; ·: 900~1499
; ·: 1500~1799
; 18000

TrafficLight:
    call    ShowCount

    mov dx, port8255B

mainGreen:             ; ·: 0~599
    cmp tcount, 600
    ja  mainYellow
    mov al, lampC
    out dx, al
    jmp lampDone

mainYellow:            ; ·: 600~899
    cmp tcount, 900
    ja  subGreen
    mov al, lampC[1]
    out dx, al
    jmp lampDone

subGreen:              ; ·: 900~1499
    cmp tcount, 1500
    ja  subYellow
    mov al, lampC[2]
    out dx, al
    jmp lampDone

subYellow:             ; ·: 1500~1799
    cmp tcount, 1800
    ja  finish
    mov al, lampC[3]
    out dx, al
    jmp lampDone

finish:
    mov tcount, 0

lampDone:
    call ShowCount
    jmp MainLoop

;==============================================================================
; ʾ뽻ͨƶӦ(6s,3s,6s,3s => 1800)
ShowCount proc
begin:
    mov dx, port8255A

; ·(6) = 0~599 => 6~1 (ÿ1001)
; 0~100 => 6
; 100~200 => 5
; 200~300 => 4
; 300~400 => 3
; 400~500 => 2
; 500~600 => 1

g6:
    cmp tcount, 100
    ja show5
    mov al, 7Dh     ; ʾ6ʾ
    out dx, al
    jmp doneShow

show5:
    cmp tcount, 200
    ja show4
    mov al, 6Dh     ; 5
    out dx, al
    jmp doneShow

show4:
    cmp tcount, 300
    ja show3
    mov al, 66h     ; 4
    out dx, al
    jmp doneShow

show3:
    cmp tcount, 400
    ja show2
    mov al, 4Fh     ; 3
    out dx, al
    jmp doneShow

show2:
    cmp tcount, 500
    ja show1
    mov al, 5Bh     ; 2
    out dx, al
    jmp doneShow

show1:
    cmp tcount, 600
    ja mainY3
    mov al, 06h     ; 1
    out dx, al
    jmp doneShow

; ·(3) = 600~899 => 3~1
; 600~700 => 3
; 700~800 => 2
; 800~900 => 1

mainY3:
    cmp tcount, 700
    ja mainY2
    mov al, 4Fh     ; 3
    out dx, al
    jmp doneShow

mainY2:
    cmp tcount, 800
    ja mainY1
    mov al, 5Bh     ; 2
    out dx, al
    jmp doneShow

mainY1:
    cmp tcount, 900
    ja subG6
    mov al, 06h     ; 1
    out dx, al
    jmp doneShow

; ·(6) = 900~1499 => 6~1
; 900~1000 => 6
; 1000~1100 => 5
; 1100~1200 => 4
; 1200~1300 => 3
; 1300~1400 => 2
; 1400~1500 => 1

subG6:
    cmp tcount, 1000
    ja subG5
    mov al, 7Dh     ; 6
    out dx, al
    jmp doneShow

subG5:
    cmp tcount, 1100
    ja subG4
    mov al, 6Dh     ; 5
    out dx, al
    jmp doneShow

subG4:
    cmp tcount, 1200
    ja subG3
    mov al, 66h     ; 4
    out dx, al
    jmp doneShow

subG3:
    cmp tcount, 1300
    ja subG2
    mov al, 4Fh     ; 3
    out dx, al
    jmp doneShow

subG2:
    cmp tcount, 1400
    ja subG1
    mov al, 5Bh     ; 2
    out dx, al
    jmp doneShow

subG1:
    cmp tcount, 1500
    ja subY3
    mov al, 06h     ; 1
    out dx, al
    jmp doneShow

; ·(3) = 1500~1799 => 3~1
; 1500~1600 => 3
; 1600~1700 => 2
; 1700~1800 => 1

subY3:
    cmp tcount, 1600
    ja subY2
    mov al, 4Fh     ; 3
    out dx, al
    jmp doneShow

subY2:
    cmp tcount, 1700
    ja subY1
    mov al, 5Bh     ; 2
    out dx, al
    jmp doneShow

subY1:
    cmp tcount, 1800
    ja doneShow
    mov al, 06h     ; 1
    out dx, al
    jmp doneShow

doneShow:
    ret
ShowCount endp

;==============================================================================
; ʱ
delay   proc    near
    push    ax
    push    cx
    push    dx
    mov dl, potVal
x1:
    mov cx, 0ffh
x2:
    loop    x2
    dec dl
    jnz x1
    pop dx
    pop cx
    pop ax
    ret
delay   endp

;==============================================================================
; жϷ
int_proc proc far
    push ax
    push dx
int1:
    inc tcount
    mov al, 20h
    mov dx, io8259_0
    out dx, al
    pop dx
    pop ax
    sti
    iret
int_proc endp

code ends
end start
